comonad-4.0: Comonads

Portability | non-portable (fundeps, MPTCs)
Stability | experimental
Maintainer | Edward Kmett <ekmett@gmail.com>
Safe Haskell | Trustworthy

Control.Comonad.Env.Class

Description

# Documentation

class Comonad w => ComonadEnv e w | w -> e where Source

Methods

ask :: w a -> eSource

Instances

ComonadEnv e w => ComonadEnv e (IdentityT w) |
ComonadEnv e ((,) e) |
(ComonadEnv e w, Monoid m) => ComonadEnv e (TracedT m w) |
ComonadEnv e w => ComonadEnv e (StoreT t w) |
Comonad w => ComonadEnv e (EnvT e w) |

asks :: ComonadEnv e w => (e -> e') -> w a -> e'Source